##found @ https://amiibodojo.com
training = {
'Link' : {'head': '01000000', 'data':[
			["Neutral Attack","In Smash 4, Link’s Jab was instrumental to his climb up the tier list. While Jabs as a whole seem less relevant in Ultimate, his can still prove deadly when he needs to whip it out. Link can use this move to interrupt pretty much anything, and will gladly do so. He seems to be one of the few amiibo that will easily learn his Jab."],
			["Forward Tilt","A hard swing over the head. While it doesn’t have the power of his Forward or Up smash, it can still kill towards high percents and comes out quicker. With the longer reach link has in this game, this is an insanely good move, and the knockback can easily earn Link stage control, or even a KO."],
			["Up Tilt","Link quickly arcs his sword over his head and hits both sides, albeit not that hard. Link can juggle this move two to three times depending on the enemy’s damage, and can follow up with a Neutral Air or an Up Smash."],
			["Down Tilt","Every sword character in Ultimate seemingly has the same Down Tilt; he jabs his sword at foot level and can do it over the edge to interrupt some recoveries, and can combo into Neutral or Forward Air."],
			["Forward Smash","His best kill move with a new trick, Link swings his sword twice. The first has good launching power on its own, but both hits connecting spells for a very quick KO tool. Link’s Forward Smash will now fire a beam out while he is at 0%. It’s not necessarily powerful but it’s faster than his boomerang and goes as far. No reason to avoid it. During low levels, this beam will confuse his AI into only using one half of his Forward Smash, however this is fixed by the time he reaches 50. This should be prioritized as your strongest killmove."],
			["Up Smash","Link swipes his sword upwards three times, chaining easily with the third hit having most of the launching power. Much like Smash 4, it’s one of the most effective aerial punishes in the game, and Link’s AI can make it hit before any opponents trying to sneak in a Down Aerial from above. Aside from being his second best kill move, it racks up a nice amount of damage and keeps the opponent off the ground, however the lag is easily punished, especially by opponents with a Tether Grab."],
			["Down Smash","Link swipes in both directions, front first. A decent edgeguarding tool and a finisher at high percents."],
			["Dash Attack","Amiibo finally use their dash attack! Link’s in particular is nasty, it’s quick(ish) and has great kill potential, however it’s easily punished if missed or shielded."],
			["Neutral Aerial","Link uses this often as an interrupt and a gimping tool: if he’s caught in an aerial spree he will kick out and put some distance between him and the opponent. In terms of gimping, Link will jump down to his opponent and hit with this, and use his extra jump to safely recover. Link can be taught to buy space with this move, as it’s knockback is pretty hefty and can easily restore neutral game."],
			["Forward Aerial","Link likes to short hop with this one as a surprise. It’s his favorite aerial, and a solid killmove, off or on stage. He will combo this out of down throw, however it doesn’t always hit and sometimes he prefers Forward Smash, usually at lower percents."],
			["Up Aerial","A predictable but solid stab, with decent launching power. Hard to hit but pays off if used properly. When his toolkit also contains Up Smash, it’s probably safer not to bother with this one."],
			["Down Aerial","Definitely not to be used above stage; use only as a spike, and even that is not recommended."],
			["Back Aerial","Another solid kill move in the air. While Forward Smash is better, sometimes you don’t have a choice which to use and sometimes your amiibo won’t either. No sense not teaching it at least a handful of times, make sure he knows it kills. At lower percents, you can land two of these on an airborne opponent before hitting the ground."],
			["Grab","For the first time ever Link does not have the hook shot. This makes his Grab much better, as it’s faster and harder to punish, however it also has less reach, removing it as a midrange option and removing his tether recovery, which brings his recovery from mediocre to slightly bad."],
			["Forward Throw","Not a kill or combo throw, no real use outside of getting the opponent off stage. It’s always a good idea to teach your amiibo to throw to the nearest edge."],
			["Back Throw","Same boat as the Forward Throw, just chuck your opponent to the closest edge so they get the point."],
			["Up Throw","One of the only notably nerfed moves on his kit, it doesn’t kill anywhere near as easily, not really a useful move anymore"],
			["Down Throw","Forward Smash, Forward Air and Neutral Air combo well out of this one, however it’s probably better to just chuck them to the nearest edge."],
			["Hero’s Bow","The only change to this move is the ability to pick up arrows and fire two at a time or chuck them. Link doesn’t fire them on stage much, and when he does the opponent is usually closer and picks it up first, and will just sort of chuck it at Link. Sadly, Link does the same if he’s lucky enough to get ahold of it. No clever two-arrow tricks."],
			["Boomerang","So long, Gale boomerang! The classic one returns, as any good boomerang should. Link loves to use this as a neutral option and will bludgeon an opponent almost literally to death with it. It can be angled when it’s thrown and will ricochet off the ground, allowed you to evade his shield if you hit right in front of his feet. He will throw it downwards towards recovering foes and try to gimp them, or simply get more damage off. He throws it towards the stage as he recovers, or sometimes behind him as he recovers so it comes back on the stage and hits the opponent as he rolls past them. He will learn quite a few combos off of the boomerang if taught, but knows very few without intervention."],
			["Hero’s Spin","Link sometimes uses it on stage, however not like he did in 4 where he’d edgeguard with it; sometimes he just uses it. Not the best habit, not the worst, just punish it if you see it. Only use it for recovery."],
			["Remote Bombs","Now we get to the fun part. Firstly, Link will sometimes still hit himself with the bombs. He mainly does this because he sees himself as collateral damage in this situation regardless of his percent, as long as it hits the enemy. Other times, he detonated as the enemy chucks his bomb back at him, making the delay just enough to hurt him. The last category is when he forgets how they work and only hits himself for no reason. On to the good parts, he will quite easily combo off of the blast if the enemy is sent towards him, usually with a Fair or Upsmash. He will also hurl these at recovering opponents to terrorize them as they try to return the stage. He will Z drop them to interrupt and gimp opponents, He will throw them at your face without detonating so he can follow with a dash attack or forward smash, he’ll do all kinds of things with these bombs. The only thing he won’t learn to do is use them to recover."]
		]},

'Kirby':{'head': '1f000000', 'data':[
			["Neutral attack (Vulcan Jab)","An infinite jab that comes out very quickly. Certainly not a move to focus on; only use it infrequently and at point blank range."],
			["Forward tilt","One of Kirby’s fastest moves and a great close-ranged “get-off-me” attack. It has surprisingly high KO power and can kill opponents past 130% on the edge of flat stages."],
			["Up tilt","A great combo starter that can link into itself and lead to an up aerial. Use it to catch landings and to start combos into aerial moves."],
			["Down tilt (Squish Kick)","A crouching kick that can trip opponents. This can then lead into a mulitude of options including dash attack or forward smash."],
			["Dash attack (Burning)","One of Kirby’s premier KO options. It’s just a bit on the slow side, but can kill its victims very early at the edge of stages. It doesn’t fall off platforms, so it’s safe to use."],
			["Forward smash (Smash Kick)","Kirby’s strongest non-special move and one of his most reliable finishers. It moves Kirby forward, which helps it to cover additional range. Use it against the amiibo at high percentages."],
			["Up smash","Kirby’s greatest aerial punish. Use it to catch the amiibo when it is falling from above. Best used on high platforms."],
			["Down smash","It’s not quite as strong as forward smash or up smash, but it sends opponents at a horizontal angle that can make recovering difficult. Especially effective against characters with poor recoveries."],
			["Neutral aerial (Twinkle Star)","A spin attack that deals moderate damage and knockback. It’s somewhat slow, making it a bit outclassed compared to Kirby’s other aerial moves. Still fine to use, just a bit less than the other aerials."],
			["Forward aerial","A spin kick that hits three times. It can be used after a forward throw at low percentages, or off-stage to gimp enemies."],
			["Back aerial","A surprisingly fast backwards kick that can get quick KOs. Kirby’s strongest aerial attack. Should be used rather often."],
			["Up aerial","It can juggle opponents, especially at low percentages. Up tilt can lead into multiple up aerials. It can also KO opponents if used near the top blast zone."],
			["Down aerial","Kirby’s most reliable combo starter and gimping tool. It links into literally anything and should be used repeatedly against off-stage opponents. Use this one a lot."],
			["Forward throw","It can lead into a forward aerial at low percentages. Other than that, it’s somewhat weak and cannot KO reliably."],
			["Back throw","Can combo into back aerial at very low percentages. It can KO highly damaged opponents at the edge of the stage."],
			["Up throw (Air Drop)","Most effective on stages with raised platforms. Doesn’t have any follow-ups, but can KO at high percentages."],
			["Down throw","Kirby’s strongest throw – in terms of damage, at least. Use it at low percentages to rack up damage on the opponent."],
			["Inhale","It’s been notably buffed from Smash 4. Not something to focus on, though, as the amiibo still can’t use all of the Copy Abilities effectively. Only use it infrequently during training."],
			["Hammer Flip","Mostly useless unless the opponent’s shield breaks. Kirby’s amiibo does not know to punish a shield break with Hammer Flip; this must be explicitly taught to it."],
			["Final Cutter","Kirby’s amiibo uses this a bit too often. Only use it when recovering, and try not to get hit by the amiibo’s Final Cutter in the meantime."],
			["Stone", "It’s fine to use this move every once in a while when launched far upwards, but don’t use it too often, as it leaves its user vulnerable to being grabbed."]
		]},

'Pikachu' : {'head': '19190000', 'data':[

			["Headbutt (Neutral attack)","A fast headbutt with minimal range. It’s only useful against opponents at point blank. Since amiibo are really active now, there often won’t be a chance for Pikachu to use Headbutt. Definitely not a move to focus on."],
			["Forward tilt","A moderately-ranged double kick. It can be used as a get-off-me move at close range. Not very effective against opponents who like to jump around a lot, but can keep grounded foes away. Use it infrequently."],
			["Up tilt","A fast tail swipe. Most effective against falling opponents, so use it wisely to rack up damage fast. Don’t use it against a grounded enemy."],
			["Down tilt","Another fast tail swipe, except right above the ground. Nothing special, but it can potentially start combos."],
			["Dash attack","Unlike in Smash 4, amiibo will actually use their dash attack! Pikachu’s has a respectable damage output, and can even KO opponents at high percentages. Use it infrequently but not too often, as it leaves the character vulnerable afterwards."],
			["Forward smash","A slow but powerful attack. It’s best not to use this one raw. If you break your amiibo’s shield, charge it up. But never charge a smash attack expecting your amiibo to walk into it: sure, it might connect, but your amiibo will start overcharging its smash attacks like a fool."],
			["Up smash","Weaker than in Smash 4, but still worth using. Most effective against an aerial enemy. Don’t go spamming it, and make sure to time it well, because it has a late sourspot."],
			["Electric Flower (Down smash)","A rapid electrical spin. It can be used to catch rolls or cover grounded ledge options. It’s also quite fast, so it’s a good idea to use this one every once in a while."],
			["Neutral aerial","Excellent move. Hits multiple times and chains into itself, especially on Battlefield-form stages. Try to set up combos with neutral aerial. It feels strange to be able to finally say it, but yes, your amiibo will learn to combo with it!"],
			["Forward aerial","An electrical corkscrew attack that can be used to gimp opponents. Pikachu’s got a great recovery, so it can afford to go off-stage and try to intercept its enemy."],
			["Glider (Back aerial)","Also known as “the flying pizza”, Pikachu’s back aerial is a decent gimping tool that can drag opponents to the bottom blast zone. Be careful when using it, as you don’t want to self-destruct."],
			["Electric Screw (Down aerial)","It can now meteor smash! Go off-stage and try to hit your amiibo with its sweetspot. For being a meteor smash, it’s really fast and strong. Put it to good use."],
			["Grab","In Ultimate, amiibo almost never grab. Pikachu is no exception. It doesn’t seem to have any confirmed throw combos, so if you happen to grab your amiibo (which you shouldn’t go out of your way to do), throw it towards the nearest blast zone."],
			["Thunder Jolt","If you don’t want to go off-stage, you can hassle recovering opponents with repeated Thunder Jolts. Or you could use it from afar to link into a neutral aerial!"],
			["Skull Bash","Your go-to recovery if you get launched near the left or right blast zone. Other than that, don’t use this attack at all. It leaves you vulnerable."],
			["Quick Attack","An excellent recovery move! Just don’t use it as an attack. Pikachu was prone to spamming it in the previous title."],
			["Thunder","It’s fine to use this move every once in a while, but don’t go crazy. It isn’t something to prioritize."]


]},

'Ness': {'head': '22800000', 'data':[

			["Neutral attack","A three-hit jab. Inflicts weak damage, but has fast startup. It’s best used at point blank to keep the opponent at bay, but isn’t a move to heavily prioritize."],
			["Forward tilt","A quick kick that can be angled up or down. Its startup is slow for an attack of its range. Best used when the opponent is about a character length away."],
			["Up tilt","Much more useful than in Smash 4. It can be used as a kill move at high percentages, but its main draw is that it can combo into an up aerial. Definitely an attack to use frequently."],
			["Down tilt","Unlike in the previous title, it no longer trips enemies. Its hitbox is very small, and because amiibo jump fairly often, it rarely connects. Do not prioritize this move."],
			["Dash attack","Three bursts of PSI are fired at an opponent. It’s kind of situational and leaves Ness vulnerable if he misses the attack. Use it every once in a while if desired; otherwise, avoid this move for the most part."],
			["Forward smash (Batter Up!)","A slow bat swing that can reflect projectiles. It’s difficult to hit an opponent caught in PK Fire with forward smash due to its launch angle, leaving the move mostly outclassed by faster options. Its main use is to reflect projectiles, which the amiibo knows to do fresh out of the box."],
			["Up smash (Around the World)","A quick get-off-me move that can be used out of shield. Its power has been ramped up from Smash 4, and now serves as a viable kill move at higher percentages. One of Ness’ recommended finishers."],
			["Down smash (Walk the Dog)","A yo-yo attack that covers both sides. Do not use its charging hitbox, even at the ledge. As mentioned before, the amiibo will learn to overcharge its smashes. Otherwise, down smash is a recommended kill move and neutral option."],
			["Neutral aerial","A diagonal spin with solid range and power. Best used out of a short hop."],
			["Forward aerial","Hits multiple times. A down throw can lead to a string of forward aerials depending on how the opponent adjusts their launch angle."],
			["Back aerial","A fast, powerful move that comes as a recommended kill option. Even out of a short hop, it can KO at very realistic percentages."],
			["Up aerial","Strikes multiple times with good kill power to boot. An up tilt can link into an up aerial. Great combo for a Ness amiibo to learn."],
			["Down aerial","Mostly useless. Ness should not be going off-stage in any capacity, making its meteor smash capabilities pointless. Avoid down aerial during training."],
			["Throws","Ness’ forward and back throws are the main two to focus on; his back throw is extremely powerful as a kill move and should be taught at high priority. His forward throw should only be used to get the opponent off stage or kill at extremely high percents. His up throw is not that great and his down throw, while a combo starter, is not a good habit to teach."],
			["Neutral Special(PK Flash)","It has been nerfed from Smash 4, and is now 100% useless. Do not use PK Flash at all during training. When the amiibo inevitably uses it uncharged, be sure to move in and punish without getting hit."],
			["Side Special(PK Fire)","Ness’ best damage-racking tool. It can link into itself, an up smash, an up tilt, or a grab. It has less ending lag in the air and can be used at the edge to catch opponents who recover high. Spam PK Fire to no end and the amiibo will immediately become stronger."],
			["Up Special (PK Thunder)","Unlike in Smash 4, Ness’ AI no longer uses PK Thunder 2 as an on-stage attack. Instead, it will chase opponents with the ball of electricity. When the amiibo is off-stage, hit it with PK Thunder. Do not hit the amiibo if it is in freefall; let it be KO’d."],
			["Down Special (PSI Magnet)","Ness’ amiibo knows how to use this move already. There is no need to teach its functionality. Only use it to absorb the amiibo’s projectiles and restore health during training."],

]},

'Falco' : {'head': '05810000', 'data':[

			["Neutral Attack","Two swift jabs from Falco that leads into a flurry of jabs that ends with a kick from above. This move is good for stunting approaches from the front, use this in a pinch if you need a fast move to bail you out as it comes out on frame 2."],
			["Forward Tilt","A forward kick from Falco that can be angled down or up. At low percents this move won’t push them that far back but it can combo into things like down tilt, at medium percents this move begins to push back further giving you space to breathe."],
			["Up Tilt","Two fast and arcing jabs overhead. This move is by far the most important on the ground when trying to start long combo strings. This move does hit opponents as long as they are in front of Falco, but you primarily want to look for them to be above you to use it as an anti-air."],
			["Down Tilt","Swings his tail out in a circular motion in front of him. Down tilt is one of the more important moves on the ground, as it puts them in the air-right where Falco wants them. This move can also kill at relatively high percents if you hit the sweet spot."],
			["Dash Attack","A rush forward with a flying frontal kick. This move sends them at the perfect angle for plenty of Falco’s aerial combo starters. Use this to punish landings, as it has decent distance and active frame time."],
			["Forward Smash","Falco lifts his arms up and swings them down onto his opponent dealing considerable knockback. This smash attack is very useful when you’re near the ledge, as it can kill early and puts them off stage, which is where Falco gets most of his kills. Use this as an onstage kill option, but don’t prioritize it; your amiibo needs to primarily be an air fighter."],
			["Up Smash","Kicks two times above him sending his opponent soaring. This is one of Falco’s combo smash attacks and his fastest smash attack. It can also kill once your opponent gets into the higher percents."],
			["Down Smash","A perfect split, kicking both legs in front and behind him and sending the opponent flying horizontally. This smash attack is strong and decently fast, and sends almost fully horizontally which can lead into a laser or down air."],
			["Neutral Air","Spins his arms around much like his jab attack. This attack can be used to combo from all the tools that send your opponents into the air, but its range makes it outclassed by his other aerials. It may be better to train as a defensive option, or just a quick way to catch their opponents off."],
			["Forward Air","Spins his entire body horizontally using his beak as a tipper. This move is far more useful that Falco’s neutral air when in combos. You can even use this move with instadrop to land onto people! This is a high priority move, both as a KO option and an edge guarding tool off stage."],
			["Back Air","A quick kick behind him delivering a powerful kick. This is Falco’s strongest kill move based on his style, and should be heavily prioritized."],
			["Up Air","A swift overhead kick.. This move is one of the main moves you want to be using to combo out of up throws and up tilts. Anytime they are in the air, you want to up air them if possible. Up air also combos into itself, making it one of Falcos main juggle tools."],
			["Down Air","A downward kick that delivers a satisfying spike. It combos with instadrop perfectly and can set up into grabs, up tilts, and smash attacks. This is also Falco’s main way to kill people off stage if they recover low, so definitely teach him to prioritize this move."],
			["Throws","Falco’s throws all have combo potential besides back throw, which eventually starts to kill at high percents, but down throw and up throw are Falco’s main go-to combo throws as down throw combos into forward air and up throw combos into up airs. Forward and Back throw can also assist in getting the opponents off stage which is useful if you’re looking for a forward aerial or down air spike off stage!"],
			["Blaster (Neutral Special)","If you’re using Instadrop, Blaster won’t be useful outside of gimping jumps off stage or forcing low recoveries to look for a down air, but Falco’s Blaster does 3% per laser and can be good against characters that want to zone!"],
			["Falco Phantasm(Side Special)","Dashes forward, leaving an afterimage behind him. This move primarily is usually used to extend recover as you can act out of it after using it, but be careful as you can only use it once while in the air if you do not get hit. There aren’t many situations where this is good to use on stage, so it’s probably better to avoid for anything besides recovery."],
			["Fire Bird (Up Special)","Charges up in flames and flies in any direction held. This will be your primary recovery tool. I would not suggest using it on stage for damage, as Falco will begin to randomly fire bird upwards at nothing which makes him a sitting duck (That was Nozomu’s joke not mine). You can use this move from below or horizontally or even higher up from the stage, though Falco Phantasm is more useful horizontally."],
			["Reflector (Down Special)","Unlike Fox, Falco kicks his reflector out in front of him to damage his opponent and to reflect projectiles. This is the primary tool you need to use when teaching Falco how to deal with projectiles. With the presence of zoning and camping in the Amiibo meta, this move can give Falco an edge against them."],

]},

'Lucina' : {'head': '21020000', 'data':[

			["Neutral Attack","Two quick sword swipes. This attack is useful to throw in as a mix-up. This is Lucina’s fastest move, but down tilt and forward tilt tend to be more useful due to there damage and knockback."],
			["Forward Tilt","Essentially a better neutral attack that is useful to interrupt attacks that forward smash would be too slow to punish."],
			["Up Tilt","Up air and up tilt compliment each other nicely. Use up tilt to launch opponents into the air and use up air to keep them in the air. With its wide hitbox and launching power, this is actually a decent KO move for a tilt."],
			["Down Tilt","A fast stab at feet level with low end lag means this is a great poke tool. This move really shines in its application at the ledge, where she can attempt to gimp opponents by preventing them from grabbing the edge. Most amiibo can still recover after getting hit by a down tilt at the edge, where they try to recover again and can possibly get hit by another down tilt. That cycle can go on for a while, racking up a ton of damage over time."],
			["Dash Attack","A great grounded option to punish moves with high end lag. Combine this move with effective dash dancing and it really shines. The main thing to watch out for is to not use this move too much, as it lacks kill power."],
			["Forward Smash","This is easily Lucina’s best move in her entire kit. This is move can be used to both rack up damage and gain KOs. It is especially useful for punishing ledge options as she can effectively ledge trap opponents by forward smashing anything they do. Even spamming forward smash can do somewhat well, until the stale moves mechanic makes it do almost nothing."],
			["Up Smash","Up smash should really only be used on platform stages to hit opponents on platforms above her. On flat stages, forward smash is better in almost every situation."],
			["Down Smash","A quick slash on either side that launches opponents a hefty distance. This move would be great but is overshadowed by forward smash in almost every way. It still has its niche situations, such as ledge trapping, but forward smash should pretty much be used any other time."],
			["Neutral Air","By default, Lucina likes to use neutral air and will even use it despite you never teaching it to her. This can be problematic as she naturally tries to use it to edge guard and land with, which tends to result in getting punished. Despite this, this is still a useful aerial move as it kills off the side at higher percents."],
			["Forward Air","This is Lucina’s second-best aerial move because she can often string multiple forward airs together. It is just a really solid move that is essential to an aerial style Lucina. Also, due to her amiibo’s poor use of her down air, this is relatively the only edge guarding move you should bother teaching; usually one swat from this move is enough to gimp most fighters on the roster."],
			["Back Air","A powerful attack that tends to be overshadowed by Lucina’s other aerial moves. It can be used to kill, but that is better left to her other moves. Teach her its applications and what situations to use it in, and nothing more."],
			["Up Air","Lucina’s best aerial move. Use this to juggle opponents and kill at higher percents. What makes this move especially great is how well it synergizes with down throw, up tilt, and itself. It’s great at hitting opponents on platforms above you."],
			["Down Air","This move is typically only useful on stages with platforms. Falling through the platform and landing with down air is a great option, especially since amiibo tend to get stuck on platforms. As stated above, this move really should not be used to edge guard. She rarely hits the spike hitbox of the move, sometimes launching her opponents upwards instead, putting her in a dangerous situation off stage."],
			["Throws","At low to mid percents down throw is Lucina’s best option. It combos freely into up air on most characters while putting them in a juggle situation where Lucina can string multiple aerials together. At higher percents up throw puts amiibo in a disadvantage state where Lucina can attempt to go for aerials. When near the ledge back or forward throw should be used when appropriate to throw the opponent off stage."],
			["Shield Breaker (Neutral Special)","Due to the great range of this move it can be used effectively as a kill move. The downside of this move is that it is a chargeable move, which amiibo seem to have trouble with learning when to charge or release the move. This move can be used, as it is named, to break shields, but as amiibo learn to parry more this move may become less and less relevant."],
			["Dancing Blade (Side Special)","Previously the best move in her kit, this has severely fallen from grace. Lucina does not angle this move properly, using the up, down, and neutral angles at what feels like random. It is probably best to avoid using this move altogether, but it can be a useful option to rack up percent."],
			["Dolphin Slash (Up Special)","Should only be used for recovering, as whiffing a dolphin slash leaves Lucina open to being punished severely."],
			["Counter (Down Special)","In general, this move should never be used. Amiibo have trouble using counters reactively, meaning when they do choose to counter they leave themselves open for a harsh punish."],

]},

'YoungLink' : {'head': '', 'data':[

			["Neutral attack","Two sword swings followed by either a solid jab or a flurry attack, ending with slightly weaker stab. Comes out very fast and is a good interrupt for any situation."],
			["Forward tilt","A fast swing over the head. This is in no way as essential as Link’s forward tilt, but it’s still a good move with higher knockback and damage than his neutral attack."],
			["Up tilt","Another fast overhead swing. Unlike Link’s up tilt, this one starts at the front and goes almost all the way down the back side. It’s fast and leads into many of his good options. A vital move to Young Link’s success."],
			["Down tilt","If his sword were longer, this move would be more useful. Definitely not important to teach, but the occasional Down Tilt followed by Forward Air or Up Special is always good; use this only for occasional combo setups, as it’s not a good move for him to rely on."],
			["Dash attack","A running swing that he puts his whole body into. A notable bit of startup lag, but not much ending. If your Young Link is recovering high, you can easily catch him as he goes for the ledge with this move."],
			["Forward smash","Two forward swings with the Kokiri Sword. A decent KO move with enough speed to be a safe punish option on many whiffed attacks. Definitely your main KO move for amiibo."],
			["Up smash","Three slashes upwards, with a decent bit of killing power considering Young Link’s small size. A good punish for landing lag or a whiffed air attack."],
			["Down smash","A knee-high swing on either side. This is best used as a ledge-trapping tool, but it’s speed and knockback make it considerable no matter what situation."],
			["Neutral aerial","The most important melee move in your kit. In it’s initial startup (hard neutral air) it has considerable power and knockback, even being a KO move at high percents. It’s low landing lag, paired with low knockback during the later hitbox (soft neutral air) make this go with absolutely any move. You can edge guard with this move, managing a falling and a rising one and still getting back to the ledge without having to use your recovery. You can fastfall with this move and hit the soft hitbox to combat zoners such as Link or Mii Gunner. Essentially, you can do anything with this move; you just have to mix it up with your projectiles and stronger KO moves."],
			["Forward aerial","Two sword slashes. This is a decent KO move, however it can only really be landed far above stage due to it’s relative slow speed and Young Link’s falling speed. Try to catch your amiibo recovering high with this."],
			["Back aerial","Two backward kicks. The second has decent knockback, and you can fastfall with this move and only land the first kick, which allows for some seriously powerful follow-ups."],
			["Up aerial","A straight upward stab. This is one of your better KO moves (not that you have many), and the hitbox is disjointed enough to save you from most downwards attacks. Combo with down throw or any upwards launching move for some good damage or KOs."],
			["Down aerial","A downwards stab. Not really disjointed enough to be consistent, and in most cases a fastfall neutral air is better; It really comes down to feeling on when to use this one; just make sure he isn’t relying on it."],
			["Grab (Hookshot)","Do not ever (and I mean ever) use this move to recover. If you would recover with z-aerial (Midair Hookshot), air dodge instead. Do everything you can to discourage him from recovering with this. On stage, however, this extended grab is very useful. Punish shields, whiffed smashes, or landing lag and follow up with a throw best suited to the situation. The amiibo counts its grab and z-aerial as two different moves, so attacking it with grab will not necessarily increase its chances of self-destructing with a failed tether."],
			["Throws","Young Link’s throws are all usable in different situations. Both of his side throws are important for getting the opponent off-stage. When they’re too damaged for combos but not enough for a KO, just throw them to the nearest edge. If their percent is low, down throw can combo into quite a few moves depending on the exact damage. His up throw can kill at high percents, which you will see a lot as Young Link due to his limited kill options. Make sure he knows he can kill with this."],
			["Fire Arrow","In normal competitive play, shorthop arrows are Young Link’s most powerful ranged option; in amiibo it’s a bit more complicated. If you teach him to shorthop arrow, he will think of this as a viable option any time he is in the air. This isn’t necessarily a bad thing, but it’s important to know. That aside, this is his fastest projectile and it can link into itself multiple times at low percents. Make sure to rack up lots of damage with this, but only use it at a distance! You don’t want him firing these off at melee range. I’ll stop with the puns now."],
			["Boomerang","This is a surprisingly important move in Young Link’s kit. Using it as a shield from enemy projectiles or a spacing option can prove extremely handy, and it should be used about as frequently as adult Link."],
			["Spin Attack","A spinning slash that launches foes upwards and at an arc; Unlike the other Links, this is not a KO move unless at excessively high percents. It can be followed up with a fair, a nair, a uair, or even another spin attack in the air. Most importantly, on the ground, you can do this move right out of shield and punish the amiibo spamming your shield."],
			["Bomb","Much to the dismay of any fellow Young Link mains, he will not use them to the degree of competitive play. However, when he does manage to land these, he will attempt any of the many kill confirms you may have taught him. Don’t prioritize it, but be sure to show him what they can do. The more of his kit he’s able to use, the better."],

]}, 


'Lucas' : {'head': '22810000', 'data':[

			["Neutral Attack","A trio of weak kicks that serve as Lucas’ fastest interrupt. Good to throw out to intercept moves with high startup."],
			["Forward Tilt","A small burst of PSI that can be angled. Has a sweetspot in the center of the magic diamond. The Lucas AI is extremely good at spacing this and landing the sweetspot, so be sure to teach him this one as a good on stage spacing tool."],
			["Up Tilt","An upwards PSI-powered kick that can juggle opponents depending on their weight and damage. Good for hitting those on platforms above him when an Up smash is too risky."],
			["Down Tilt","No PSI, but at lower percents it can combo into itself, especially at the ledge. Combine with a PSI Magnet, a forward tilt, or any of the dozen moves this can combo into, and your amiibo will replicate it."],
			["Dash Attack","A slow PSI attack that deals more damage at it’s tip than it’s base, and at the farther end can KO at high percents. Definitely only use as a safe punish, as this move has a lot of lag."],
			["Forward Smash","A faster, weaker version of Ness’ Bat. Deals more damage at the tip. Without a trapping PK Fire, this move is very situational, but a good KO move. Use it to reflect PK Fire or punish."],
			["PK Smash Geyser (Up Smash)","Lucas’ most powerful onstage kill move, this blast of PSI should be used sparingly-I recommend not using it at all until they are level 50. The startup and ending lag on this move is large, so this should only be used as an anti-air attack or a dodge punish if at all. Lucas’ AI will love to use this move often so use it VERY sparingly. An upside to this move is that the final frames, where it reaches it’s peak, seems to confuse opponents trying to avoid it, resulting in a decent amount of damage."],
			["PK Blow (Down Smash)","Three PSI blasts, increasing in range and decreasing in power with each one. In terms of Amiibo, this is going to be one of your main on-stage KO moves. The AI will edgeguard with this if taught, 2-framing his opponents. Not much ending lag, so not too much worry of him getting punished after, but a decent amount of starting lag. Also a good shield punish."],
			["Neutral Air","A nice approach option, he traps the opponent with a few small PSI burts, the last of which launches the opponent away, but not my much. Should mostly be used to punish an enemy getting too close or to escape getting combo’d, and can be followed up with any aerial."],
			["Forward Air","A PSI emitting kick that can KO at high percents, or otherwise just make space. The sweetspot, like his forward tilt, is second nature to the amiibo, who will get the opponent off stage with it and even get some cheap KOs at low percents if he follows off stage with this move. Definitely an important one to teach."],
			["PK Meteor Kick (Back Air)","Lucas kicks and does a backflip. The tip of this will meteor smash and is a nasty and satisfying spike. It’s quick enough to be a decent above-stage tool as well, and meteor smashing the opponent into the stage has a lot of follow up options."],
			["Up Air","A headbutt that deals decent damage and knockback; mostly useful as a KO move above stage."],
			["PK Foot Stomp (Down Air)","Can safely meteor offstage, and can be used against onstage opponents for decent damage while mostly staying out of reach, and can lock into Down Tilt combos. A main usage of this is to dance above the enemy with until one hits and you can follow up with a Neutral Air or, if quick enough, a tilt after landing."],
			["Rope Snake (Grab)","Lucas’ tether recovery. Has a decent reach and is a good recovery option. "],
			["Throws","Lucas’ forward and down throws are KO moves at the edge at high percents, his up throw is a KO at super high percents, and his down throw can be followed up with a large portion of his move set."],
			["PK Freeze (Neutral Special)","DO NOT use this move AT ALL. Lucas will not use this move properly, will spam it, and will get heavily punished for it."],
			["PK Fire (Side Special)","Your go to zoning tactic. Rack up damage, get the opponent in the air or even off stage, go in for the kill when ready."],
			["PK Thunder (Up Special)","A recovery move and an off stage killer. Chase the opponent into the blast zone or beneath the stage and force them to recover uncomfortably or get an easy kill. Lucas AI doesn’t miss a beat when chasing with this move and will get some disgusting damage and KOs."],
			["PSI Magnet (Down Special)","Use this move to absorb PK Fires and PK Thunders, including the ones he uses to recover; that trick will come in handy in Lucas mirrors. The small burst when it is released can stop an opponent enough for a follow-up or even semi-spike them offstage, which opens up all of your super early KO options."],

]},

'LittleMac' : {'head': '06c00000', 'data': [

			["Neutral Attack","A string of punches that can also be a flurry attack. This is one of the fastest attacks in the game, coming out practically instantaneously."],
			["Forward Tilt","A two-hit combo that can KO at about 100% depending on the character (assuming you land the second hit.)"],
			["Up Tilt","Mac swings his fist over his head, covering his entire body. This move can juggle, combo out of down throws at low percents, and punish any rolls or air dodges."],
			["Down Tilt","A crouching punch that doesn’t combo into anything anymore. Not a very useful move to teach your amiibo."],
			["Dash Attack","One of the fastest dash attacks in the game, this dash attack has decently long range and KO potential. Little Mac is one of the few amiibo whose dash attack is a must; very few amiibo will have the reaction time to deal with this move consistently."],
			["Forward Smash","About half of your arsenal is this move. Arc it downwards for damage and shield breaking. Upwards and Forwards are better for KOing, and while Upwards is better on light characters it’s more useful to teach the forward variant as their priority."],
			["Up Smash","A powerful uppercut. This is much better to teach him than the upwards-arced forward smash, as he will use these two moves in different situations. This is your laggiest ground move, however, so be sparing in it’s use."],
			["Down Smash","A spinning sweep with his fist. This is your best edgeguarding and ledge trapping tool. Be sparing in it’s use, however, or your Little Mac will start to prefer it over his much better forward smash."],
			["Neutral Air","Little range, but excessively fast. This is the only aerial you should teach your amiibo. It has little ending lag and can break combos. When knocked in the air, throw this move out if he is juggling you with up tilt or if he is in hitting range for any other reason and try to get back to the ground."],
			["Forward Air","A hook that can semi spike, but pitifully low damage."],
			["Back Air","A slightly faster and stronger version of the Forward Air; still not worth using."],
			["Down Air","A meteor smash with poor range, damage, and knockback, but impressive speed. Still not worth using; if your Little Mac learns this move can meteor smash he will attempt spikes and get himself killed."],
			["Throws","Little Mac’s throws are bad. Little to no combo potential and knockback, your best bet is to just teach him back throw as a possible KO option and down throw to lead into Up tilt juggle at low percents."],
			["Straight Lunge (Neutral Special)","Little Mac charges up and launches himself. Surprisingly, this is a good move, as the amiibo don’t seem that good at preparing for it, however it’s immense end lag will get punished hard."],
			["KO Punch","Little Mac’s AI has severely improved in terms of using KO Punches. He will still forget to use it sometimes, but in comparison to the previous title it’s a relief to see him land it fairly consistently. Any time you get your KO Punch make sure to use it on him, but stay away from the edge when doing so."],
			["Jolt Haymaker (Side Special)","An overhanded superman punch. This move is best used as a recovery option; using it on stage leaves too much potential for a self-destruct. He will automatically know how to use it for recovering, so you don’t need to worry about teaching that."],
			["Rising Uppercut (Up Special)","A rising flurry of fists. This move should also remain as a recovery tool and not much more."],
			["Slip Counter (Down Special)","Counters are severely nerfed in this game’s amiibo meta; the AI does not use them as consistently. However, that doesn’t mean you shouldn’t teach it. Punish every now and then with this move, but in the long run your amiibo will get more value from learning to parry than countering."],

]},


'MiiGunner' : {'head': '07c00200', 'data':[

			["Neutral attack","A fairly fast jab that works as a get-off-me move. If the opponent is too close and using a Super Missile is too risky, Mii Gunner’s neutral attack is a safe option."],
			["Forward tilt","Best used at mid- to close-range. It’s got quite a bit of startup, though, so keep this one back-burnered for the most part."],
			["Up tilt","A short uppercut with fast startup but very high ending lag. Keep away from this one, as it leaves Mii Gunner highly vulnerable afterward."],
			["Down tilt","Has extremely high ending lag, but decent knockback. Not the best idea to use this one due to its sluggishness."],
			["Dash attack","Best left unused. Mii Gunner plays best when she spams Super Missiles, and dash attack is the exact opposite of that."],
			["Forward smash","It’s somewhat slow, but it reaches far and has respectable power. It can be used as a highly situational KO move, but nothing more than that."],
			["Up smash","Hits multiple times and deals good damage. Can be used to catch aerial opponents, and is a good tertiary move to teach the amiibo."],
			["Down smash","Strikes on both sides. It has very high KO power and is Mii Gunner’s fastest smash attack. Can be used as a situational kill move."],
			["Neutral aerial","A quick sweep with high knockback. Can’t combo into anything, so it’s best to avoid this move."],
			["Forward aerial","Shoots a small laser that pushes Mii Gunner backward. It’s entirely outclassed by Super Missiles, so don’t bother much with this one."],
			["Back aerial","Quite powerful, and can be used in a pinch as a very situational kill move. Don’t focus on this one."],
			["Up aerial","A lot of range and power, but it’s quite slow. Again, don’t focus on this move. Super Missiles are Mii Gunner’s bread and butter."],
			["Down aerial","A strong meteor smash. Mii Gunner doesn’t need to go off-stage to gimp, though, because Bomb Drop and Grenade Launch are usually enough."],
			["Forward throw","Very weak and deals little knockback. Mostly useless."],
			["Back throw","Also very weak, but it can at least KO at high percentages."],
			["Up throw","One of the most damaging up throws in the game. Don’t grab much (if at all) while playing against the amiibo; none of its throws are good enough to be worth the potential ending lag of missing the grab."],
			["Down throw","Mostly useless. Doesn’t combo into too much and is outclassed because Mii Gunner could fire two Super Missiles in the time it takes to down throw."],
			["Grenade Launch","Best used infrequently as an edgeguard. Charge it up and let loose. Don’t use it if the opponent is on-stage."],
			["Gunner Missile","Mii Gunner’s best move. Spam it to no end. As silly as it sounds, Super Missile (which is fired when inputting the move like a smash attack) is what makes this character top-tier. Only stop firing Super Missiles when the opponent is directly next to you."],
			["Arm Rocket","For recovery purposes only. It can be aimed fluidly and mid-ascent, and will almost always get Mii Gunner back on-stage."],
			["Bomb Drop","Can be used in the air and at close range. Don’t use it too often, though, or else the amiibo will prioritize bombs over missiles. Missiles should be its top priority."],

]},

'IceClimbers' : {'head': '078f0000', 'data':[

			["Neutral attack","A two-hit jab with poor range. It can be used as a quick get-off-me move at point blank, but does not have much utility otherwise."],
			["Forward tilt","A horizontal hammer sweep with decent range. Most effective when used frequently against nearby opponents."],
			["Up tilt","One of the Ice Climbers’ best moves. Creates a lingering hitbox that catches aerial enemies and reliably combos into an up aerial until very high percentages. Up tilt to up aerial is an essential combo that each Ice Climbers amiibo should understand and utilize."],
			["Down tilt","A grounded attack that covers a small area. A short hop neutral aerial can follow up into a down tilt at lower percentages, which is a nice combo to teach the amiibo."],
			["Dash attack","A forward leap that serves as a surprisingly useful disruption. Its launch angle can combo into an aerial move at lower percentages."],
			["Forward smash","A powerful overhead swing. Serves as a reliable kill move that can catch opponents out of direction air dodges. Definitely a finisher to prioritize!"],
			["Up smash","An upward swing. Powerful and can punish an aerial opponent. Another strong kill move that should be prioritized during training!"],
			["Down smash (Hammer Sweep)","Each Ice Climber will sweep their hammer across the ground in a different direction. If Nana has been KO’d, the attack will only strike on one side."],
			["Neutral aerial","A quick aerial spin with weak knockback. It can combo into a down tilt, and is otherwise a solid neutral option to use out of a short hop."],
			["Forward aerial (Hammer Slam)","A spinning slam. If Nana’s hammer connects with the opponent, it will result in a powerful meteor smash. Down throw can combo into a forward aerial. This string comes highly recommended as a finisher."],
			["Back aerial","A fast backwards hammer strike. It can be used after an up tilt depending on the angle the opponent is launched."],
			["Up aerial","Another one of the Ice Climbers’ best moves. If both Popo and Nana successfully land the attack, it can KO rather early. Remember to use up tilt into up aerial as a primary damage-racking tool."],
			["Down aerial","A stall-then-fall that descends relatively slowly and deals decent damage. The move really does not accomplish much, so it is best to avoid it during training."],
			["Forward throw","A rather weak throw that doesn’t have many follow-ups. It can be used in a pinch to rack up damage."],
			["Back throw","Another weak throw. It is difficult to grab the amiibo during training due to the presence of two Popos and two Nanas (since mirror matches should be played while leveling)."],
			["Up throw","Can combo into an up aerial at lower percentages, but an up tilt is usually the better combo starter."],
			["Down throw","Combos into a forward aerial at medium to high percentages. Comes as a recommended finisher."],
			["Ice Shot","The Ice Climbers send two small ice projectiles along the ground. Its only use is to gimp off-stage opponents. Firing Ice Shot off-stage is the best technique to use when the amiibo is off-stage."],
			["Squall Hammer","Mostly useless except to recover. The Ice Climbers amiibo loves to use it without being trained to. Not the worst move, but it also does not accomplish anything. It is best to avoid Squall Hammer during training, as it leaves the climbers helpless afterwards."],
			["Belay","For recovery purposes only. There is no reason to use it as an attack. Can be used at the edge to reunite separated climbers."],
			["Blizzard","It can freeze opponents, but only at point blank. At maximum range, the attack deals abysmal damage and almost no knockback."],

]},

'PiranhaPlant': {'head': '00240000', 'data':[

			["Neutral attack","A short-ranged rapid jab that deals respectable damage. Again, it’s short-ranged, so it’s best used somewhat infrequently and at point blank."],
			["Forward tilt (Push and Pull)","A two-part attack that bites an opponent. It’s the character’s fastest grounded move and deals a good bit of damage. One of its premier grounded damage-rackers, and certainly one to use quite often."],
			["Up tilt","Not much horizontal range, but it can catch falling opponents and lead into an up aerial. It even serves as a KO move at high percentages, and its speed makes it more reliable than a smash attack."],
			["Down tilt","A downwards leaf attack that can lead into a forward tilt at low percentages. Use it somewhat frequently to set up combos."],
			["Dash attack","A reckless pot swing that deals a good bit of damage. There isn’t much use in this one, but it can be used as an aggressive maneuver to force an enemy into the air."],
			["Forward smash (Prickly Swing)","Extremely powerful and can KO under 70% at the edge. However, its ending lag leaves the character vulnerable. Only use it when you know it will connect."],
			["Up smash","Piranha Plant’s best smash attack. It’s a great aerial punish that KOs quite early from any part of the stage. Out of all the character’s smash attacks, this is certainly the one to prioritize."],
			["Down smash","A fast pot sweep that strikes on both sides. Best used to catch rolls or cover ledge options. Good to use every once in a while."],
			["Neutral aerial","Similar to Ivysaur’s neutral aerial, and strikes several times. Not the best aerial in Piranha Plant’s arsenal, but should still be used somewhat frequently."],
			["Forward aerial","It can combo into itself and gimp opponents off-stage. Piranha Plant’s recovery is top-notch, so going off-stage is usually safe. Can also be used out of a down throw."],
			["Back aerial (Fire Breath)","Really strong, but really slow. One of the laggiest aerials in the game, and should be avoided for the most part."],
			["Up aerial","Not very effective against small characters, but deals solid damage and knockback and can be used out of an up tilt."],
			["Down aerial (Flowerpot Meteor)","It’s a safe meteor smash, except the meteor smash doesn’t always happen due to the attack’s strange hitboxes. Try and connect with the bottom of the pot."],
			["Forward throw","Inflicts damage. Use it every once in a while to toss an opponent off-stage. Not much use outside of that."],
			["Back throw","Kind of powerful. Can be used at the edge for a potential KO at high percentages. Otherwise, its use is rather limited."],
			["Up throw","Piranha Plant’s premier kill throw. Can be used alongside several pummels at high percentages to KO."],
			["Down throw","A weak throw that can combo into a forward aerial. Don’t focus on combos with this throw, as it can only do so at low percentages."],
			["Ptooie","Summons a spiky ball with surprisingly potent KO power. It can be held to change its distance and angle. It’s fine to go off-stage and gimp with a forward aerial or down aerial, but Ptooie should be used as an edgeguard as well."],
			["Poison Breath","Always keep it charged. It’s best placed towards the middle of the stage or near the edge but not directly above it. Inflicts heavy damage to shields. Other amiibo are often able to avoid taking full damage from it."],
			["Piranhacopter","Recovery purposes only. Piranha Plant’s amiibo will always recover high with Piranhacopter at low levels. As long as you retaliate with an attack, this habit will stop by the time it reaches Level 50."],
			["Long-Stem Strike","Use it every once in a while to gimp opponents or to attack from afar. Don’t use it too often or else the amiibo will learn to rely on it. Definitely don’t want that happening."],

]},
}

DatablockOffest= 0xE0
un0Offest= 0x03
un1Offest= 0x0F
un4Offest= 0x76

knowLocations = {
'un0':{},
'un1':{},
'un4':{

		0x168-DatablockOffest-un4Offest:	"Attacking???",
		0x169-DatablockOffest-un4Offest:	"Attacking???",
		0x16A-DatablockOffest-un4Offest:	"Attacking???",
		0x16B-DatablockOffest-un4Offest:	"Attacking???",

		0x181-DatablockOffest-un4Offest: 	"Taunting! its value based, so the greater the Hex Value the more the Amiibo will taunt!",
		0x171-DatablockOffest-un4Offest: 	"Grabbing! Also Value Based, but not as great as Taunting.",

		0x18A-DatablockOffest-un4Offest:	"A special Neutral",
		0x18B-DatablockOffest-un4Offest:	"A special Side",
		0x18C-DatablockOffest-un4Offest:	"A special Up",
		0x18D-DatablockOffest-un4Offest:	"A special Down",

		0x19A-DatablockOffest-un4Offest: 	"B special Neutral",
		0x19B-DatablockOffest-un4Offest:	"B special Side",
		0x19C-DatablockOffest-un4Offest:	"B special Up",
		0x19D-DatablockOffest-un4Offest:	"B special Down",
	}

}

#for loc in knowLocations['un4']:
#	print ("0x%0.2X" % loc)